﻿/* Preloader Class */
/* Developed by Carlos Yanez */

package classes
{
	import flash.display.MovieClip;
	import flash.text.TextField;
	import flash.events.Event;
	import flash.events.ProgressEvent;
	
	public class Preloader extends MovieClip
	{
		/* Variable to store dataTextField param in the constructor function */
		
		private var dataTextField:TextField;
		
		/* Start function */
		
		public function start(dataTextField:TextField):void
		{
			this.dataTextField = dataTextField;
			
			this.loaderInfo.addEventListener(ProgressEvent.PROGRESS, onProgress);
			this.loaderInfo.addEventListener(Event.COMPLETE, onComplete);
		}

		/* Set the percent loaded to the textfield */

		private function onProgress(e:ProgressEvent):void
		{
			/* Bytes related local variables  */
			
			var loadedBytes:int = Math.round(e.target.bytesLoaded  / 1024);
			var totalBytes:int = Math.round(e.target.bytesTotal / 1024);
			var percent:int = (e.target.bytesTotal / e.target.bytesLoaded) * 100;
			
			dataTextField.text = String(loadedBytes + " of " + totalBytes + "KB Loaded\n" + percent + "% Complete");
		}

		/* Here you can send to another frame/scene or load any other thing */

		private function onComplete(e:Event):void
		{
			/* Remove listeners */

			this.loaderInfo.removeEventListener(ProgressEvent.PROGRESS, onProgress);
			this.loaderInfo.removeEventListener(Event.COMPLETE, onComplete);

			//Do something
		}
	}
}